#!/bin/ash

[ $(whoami) != "root" ] && echo "Must run as root!" && exit 1

echo "Installing dependencies..."
apk add lighttpd curl jq bash youtube-dl ffmpeg

if [ ! -f /etc/konata.conf ]
then
	echo "Configuring bot..."
	read -p "Please enter your bot token: " token
	read -p "Please enter the bot's username (without @): " bot
	read -p "Please enter the domain for your bot: " domain
	read -p "Do you want to use a log chat? (y/n): " logans
	[ "$logans" == "y" ] && read -p "What's the log chat's chat ID? " logchat

	echo "token=$token" >> /etc/konata.conf
	echo "bot=$bot" >> /etc/konata.conf
	echo "domain=$domain" >> /etc/konata.conf
	[ ! -z $logchat ] && echo "logchat=$logchat" >> /etc/konata.conf
else
	. /etc/konata.conf
fi

echo "Installing application files..."
install -m644 lighttpd.conf /etc/lighttpd/lighttpd.conf
mkdir /var/www/konata
rand=$RANDOM
install -m755 konata.sh /usr/local/bin/konata
rm /var/www/konata/*.sh
ln -s /usr/local/bin/konata /var/www/konata/$rand.sh
install -m644 index.html /var/www/konata/index.html

echo "Requesting Telegram to use our webhook..."
curl -X POST "https://api.telegram.org/bot$token/setWebhook" \
	-d "url=$domain/$rand.sh"
echo ""
echo "The webhook has been set to $domain/$rand.sh."

echo "Starting lighttpd..."
service lighttpd start
rc-update add lighttpd default
echo "Started and enabled lighttpd."
echo "That should be everything! Enjoy your new bot!"
